#include <boost/spirit/include/qi.hpp>
#include <iostream>
#include <string>

namespace qi = boost::spirit::qi;
namespace px = boost::phoenix;
namespace ascii = boost::spirit::ascii;


typedef qi::rule<std::string::const_iterator,std::string(),qi::ascii::space_type> RuleType;
typedef RuleType* RuleTypePtr;

template <typename Iterator>
struct dynamicParser : qi::grammar<Iterator,std::string(), boost::spirit::ascii::space_type> {
    dynamicParser (std::vector<qi::rule<Iterator,std::string(), qi::ascii::space_type>* > rules) : dynamicParser::base_type(startRule) {
        rulestack = rules;
        startRule = *(rulestack.at(0));        
    }
    std::vector<qi::rule<Iterator,std::string(),qi::ascii::space_type>* > rulestack;
    qi::rule<Iterator,std::string(), qi::ascii::space_type> startRule;
};

int
main (int argc, char** argv) {
  std::vector<RuleTypePtr> myRuleVector;
  myRuleVector.push_back (new RuleType(qi::eps));//This rule is going to get replaced
  myRuleVector.push_back (new RuleType(qi::string("Hello")));
  myRuleVector.push_back (new RuleType(qi::string("Hi")));
  myRuleVector.push_back (new RuleType(qi::string("Whats up")));

  //Now magically compose a rule *with arbitrary vectorsize*
  //I have no clue how to do this
  //But it should result in:

  myRuleVector.at(0) = new RuleType ((*myRuleVector.at(1)) | (*myRuleVector.at(2)) | ((*myRuleVector.at(3))));

  dynamicParser<std::string::const_iterator> myDynamicParser(myRuleVector);

  std::string s ("Hi");
  std::string attr;

  if (qi::phrase_parse ((std::string::const_iterator)s.begin(),(std::string::const_iterator)s.end(),myDynamicParser,ascii::space,attr))
    std::cout << "Parse success" << std::endl;
  else
    std::cout << "Parse failed" << std::endl;
  return 0;
}


